var vows      = require ("vows"),
assert    = require("assert"),
express = require("express");

require("../lib/backbone-server");

// ---------------------------------------------------------------------------------------------------- //

vows.describe("Express Method").addBatch({
    
    "The 'express' property of  the Backbone Server module": {

        topic: new Telegraph.Server,
        
        "should exist": function(server) {
            assert.equal("express" in server, true);
        },

        "should be equal to an http server": function(server) {
            assert.equal(typeof server.express, "object");
        }

    },
                                      
    "Using Express, backbone server": {
        
        topic: new Telegraph.Server,
        
        "should be able to create a GET method route": function(server) {
            server.get("/route", function(req, res) {
                res.send("hi");
            });
            
          // Test existence
            assert.equal("/route" in server.routes, true);
            // Test HTTP method
            assert.equal(server.routes["/route"][0], 'get');
        },

        "should be able to create a POST method route": function(server) {
            server.post("/route", function(req, res) {
                res.send("hi");
            });
            
           // Test existence
            assert.equal("/route" in server.routes, true);
            // Test HTTP method
            assert.equal(server.routes["/route"][0], 'post');
        },

        "should be able to create a PUT method route": function(server) {
            server.put("/route", function(req, res) {
                res.send("hi");
            });
            
           // Test existence
            assert.equal("/route" in server.routes, true);
            // Test HTTP method
            assert.equal(server.routes["/route"][0], 'put');
        },

        "should be able to create a DELETE method route": function(server) {
            server.delete("/route", function(req, res) {
                res.send("hi");
            });

            // Test existence
            assert.equal("/route" in server.routes, true);
            // Test HTTP method
            assert.equal(server.routes["/route"][0], 'delete');
        }

    }                    

}).export(module);
